# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..2\n"; }
END {print "not ok 1\n" unless $loaded;}
use BottleRocket;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

$default_yorn = "YES";
$default_port = "/dev/ttyS0";
$default_module = "A1";
$default_have_lamp = "YES";
$default_lamp_module = "A2";

use Fcntl;

print STDERR "Would you like to test your FireCracker device now? [$default_yorn]:";
$yorn = <STDIN>;
chop $yorn;
$yorn = $default_yorn if $yorn eq '';
$yorn =~ tr/[a-z]/[A-Z]/;
if (($yorn =~ /^YES/) || ($yorn eq "Y")) {
	print STDERR "What port is the FireCracker attached to? [$default_port]:";
	$port = <STDIN>;
	chop $port;
	$port = $default_port if $port eq '';
	print STDERR "What is the address of a module to test? [$default_module]:";
	$module = <STDIN>;
	chop $module;
	$module = $default_module if $module eq '';
	print STDERR "Please make sure the module is off currently, then press <RETURN>:";
	$crud = <STDIN>;
	sysopen(TEST, $port, O_RDONLY | O_NONBLOCK) || 
	  die("Unable to open $port");
	print STDERR "Turning $module ON.\n";
	BottleRocket::x10_cmd(TEST, $module, "ON");
	print STDERR "Turning $module OFF.\n";
	BottleRocket::x10_cmd(TEST, $module, "OFF");
	close TEST;
	print STDERR "Did the module turn on and off? [YES]:";
	$result = <STDIN>;
	chop $result;
	$result = "YES" if $result eq '';
	$result =~ tr /[a-z]/[A-Z]/;
	if (($result =~ /^YES/) || ($result eq "Y")) {
	    print "ok 2\n";
	} else {
	    print "not ok 2\n";
	}
} else {
    print "ok 2";
}


# will add more tests when I'm awake, including checking that the commands
#  work.
